﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=12.5
@EndOfDesignText@
' #################################################################
' Page Action Bar
' #################################################################
' Name:			TD_ActionBar
' Version:		2
' Filename:		TD_ActionBar.bas (TD_ActionBar.b4xlib)
' Dev State:	(x)WIP ()Rel
' Type:			()Activity ()B4XPage ()Class ()Mod (X)CustView XUI
' -----------------------------------------------------------------
' Libs:			XUI,AUDIO, JavaObject,OKHttpUtils2,IME
' Classes:		-
' Modules:		-
' Layouts:		-
' Files:		
' -----------------------------------------------------------------
' Devloper/s:	G. Becker
' -----------------------------------------------------------------
'' #################################################################
' (C) TechDoc G. Becker | https://www.gbecker.de
' Licence: 
' Royalty Free for Private and Commercial Usage ONLY for
' B4X Anywhere licensed Members.
' #################################################################

#region Links
' tested: Name:G. Becker / 2023/10/31
' Ctrl + click to build b4xlib: ide://run?file=%JAVABIN%\jar.exe&WorkingDirectory=%PROJECT%\..&Args=-cMf&Args=%PROJECT_NAME%.b4xlib&&Args=..&Args=*.bas&Args=manifest.txt
#end region

#region Designer Custom Properties
#DesignerProperty: Key: layout, DisplayName: Layout Filename, FieldType: string, DefaultValue:
#end region

#region Globals
Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Public mBase As B4XView
	Private xui As XUI 'ignore
	Public Tag As Object
	
	Public HScrollview As HorizontalScrollView
	Public VScrollView As ScrollView
	
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
	
	HScrollview.Initialize(1,"hscrollview")
	VScrollView.initialize(1)
End Sub
#end region

#region basic
Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	mBase = Base
    Tag = mBase.Tag
    mBase.Tag = Me
	
	' scrollview setup
	HScrollview.Height = HScrollview.Panel.Height
	HScrollview.Width =mBase.width
	Sleep(0)
	If Props.Get("layout") <> "" Then setLayoutFile(Props.get("layout"))
	VScrollView.Width = mBase.Width
	VScrollView.Panel.AddView(HScrollview,0,0,HScrollview.Width,HScrollview.Height)
		
	' Add scrollview to base
	mBase.AddView(VScrollView,0,0,mBase.width,mBase.height)

End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
  
End Sub
#end region

#region custom properties
public Sub setLayoutFile(Layout As String)
	Try
		' load layout
		HScrollview.Panel.RemoveAllViews
		HScrollview.Panel.LoadLayout(Layout)
		' compute needed area to show all child views
		Dim w,h As Int
		For Each v As View In HScrollview.panel.GetAllViewsRecursive
			If v.Left + v.Width > w Then w = v.Left + v.Width
			If v.Top + v.Height > h Then h = v.Top + v.Height
		Next
		' resize inner panel based on views
		HScrollview.panel.Width = w
		HScrollview.panel.Height = h
		
		VScrollView.Panel.Height = HScrollview.panel.Height
		VScrollView.Panel.Width = mBase.Width
	Catch
		Log(LastException)
	End Try
End Sub
#end region